unit uJustifica;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function tbSpace(Len: integer): string;
var
  I: integer;
begin
  Result := '';
  for I := 1 to Len do
    Result := Result + ' ';
end;

procedure tbGetJustText(S: string; const Len: array of byte; var Lines: TStringList);

  function GetLenLine(const Index: integer): byte;
  begin
    if (Index >= Low(Len)) and (Index <= High(Len)) then
      Result := Len[Index]
    else
      Result := Len[High(Len)];
  end;

var
  I, J, NLines, LenLine, LenReq, NSep, LenSep, AddSep: integer;
  Line, Temp: string;
begin
  if Pos(#0, S) > 0 then
    raise Exception.Create('Caractere invlido: Chr(0)');

  S := Trim(S);

  { Exclui espaos duplos }
  I := -1;
  while I <> 0 do begin
    I := Pos('  ', S);
    if I > 0 then
      Delete(S, I, 1);
  end;

  NLines := 0;
  while S <> '' do begin
    I := GetLenLine(NLines);
    if (Length(S) > I) and (Pos(' ', Copy(S, 1, I)) > 0) then
      while S[I+1] <> ' ' do
        Dec(I);
    Lines.Add(Trim(Copy(S, 1, I)));
    Inc(NLines);
    S := Trim(Copy(S, I + 1, MaxInt));
  end;

  { Ajusta o tamanho de cada linha, exceto a ltima }
  for I := 0 to Lines.Count -2 do begin
    Line := Lines[I];

    LenLine := Length(Line);
    LenReq := GetLenLine(I);

    { NSep - nmero de separaes }
    NSep := 0;
    for J := 1 to LenLine do
      if Line[J] = ' ' then
        Inc(NSep);

    { Calcula o tamanho da separao }
    J := LenReq - (LenLine - NSep);
    if NSep > 0 then begin
      LenSep := J div NSep;
      AddSep := J mod NSep;
    end else begin
      LenSep := 0;
      AddSep := 0;
    end;

    for J := 1 to LenLine do
      if Line[J] = ' ' then
        Line[J] := #0;

    J := -1;
    while J <> 0 do begin
      J := Pos(#0, Line);
      if J > 0 then begin
        Temp := tbSpace(LenSep);
        if AddSep > 0 then begin
          Temp := Temp + ' ';
          Dec(AddSep);
        end;
        if Temp = '' then
          Temp := ' ';
        Delete(Line, J, 1);
        Insert(Temp, Line, J);
      end;
    end;

    Lines[I] := Line;
  end;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  List: TStringList;
  S: string;
  I: integer;
begin
  S := Memo1.Text;
  { Remove caracteres de quebra de linha, trocando #13 por espao }
  I := Pos(#13, S);
  while I > 0 do begin
    Delete(S, I, 1);
    Insert(' ', S, I);
    I := Pos(#13, S);
  end;

  I := Pos(#10, S);
  while Pos(#10, S) > 0 do begin
    Delete(S, I, 1);
    I := Pos(#10, S);
  end;

  List := TStringList.Create;
  try
    { Justifica com 4 linhas de 50 caracteres e o restante das
      linhas com 40 caracteres }
    tbGetJustText(S, [50, 50, 50, 50, 40], List);
    Memo1.Lines.Assign(List);
  finally
    List.Free;
  end;
end;

end.
